<%-- $Id: view_role.jsp 5507 2010-11-19 10:05:03Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ROLE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	private static final String getShortPermissions(Item itemType, Set<Permission> permissions)
	{
		Set<Permission> defined = itemType.getDefinedPermissions();
		StringBuilder sb = new StringBuilder();
		if (defined.contains(Permission.CREATE)) sb.append(permissions.contains(Permission.CREATE) ? "C" : "-");
		if (defined.contains(Permission.READ)) sb.append(permissions.contains(Permission.READ) ? "R" : "-");
		if (defined.contains(Permission.USE)) sb.append(permissions.contains(Permission.USE) ? "U" : "-");
		if (defined.contains(Permission.WRITE)) sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
		if (defined.contains(Permission.DELETE)) sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
		if (defined.contains(Permission.SET_OWNER)) sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
		if (defined.contains(Permission.SET_PERMISSION)) sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
		return sb.toString();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Role role = Role.getById(dc, itemId);
	
	RoleKey system = RoleKey.getById(dc, SystemItems.getRoleKeyId(Item.SYSTEM));
	final boolean hasShareToEveryone = system.getPermissions(role).contains(Permission.SHARE_TO_EVERYONE);
	final boolean hasActAsAnotherUser = system.getPermissions(role).contains(Permission.ACT_AS_ANOTHER_USER);
	final boolean hasSelectJobagent = system.getPermissions(role).contains(Permission.SELECT_JOBAGENT);
	
	final boolean writePermission = role.hasPermission(Permission.WRITE);
	final boolean deletePermission = role.hasPermission(Permission.DELETE);
	final boolean isRemoved = role.isRemoved();
	final boolean isUsed = isRemoved && role.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, role);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Roles" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(role.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this role" : "You do not have permission to edit this role"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!role.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this role" : "You do not have permission to delete this role"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=role.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this role" : "You do not have permission to restore this role"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'role.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(role)%></i></div>
			<%
			if (role.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(role.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(role.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">System ID</td>
				<td><%=HTML.encodeTags(role.getSystemId())%></td>
			</tr>
			<tr>
				<td class="prompt">Is default</td>
				<td><%=role.isDefault() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(role.getDescription())%></td>
			</tr>
			</table>
			
			<base:section 
				id="permissions" 
				title="<%="Permissions"%>"
				context="<%=cc%>"
				>			
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Share to everyone</td>
					<td><%=hasShareToEveryone ? "yes" : "no"%></td>
					<td class="prompt">Select job agent</td>
					<td><%=hasSelectJobagent ? "yes" : "no"%></td>
				</tr>
				<tr>
					<td class="prompt">Act as another user</td>
					<td><%=hasActAsAnotherUser ? "yes" : "no"%></td>
				</tr>
				</table>
				
				<div class="itemlist">
				<div class="data">
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
				<%
				Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
				
				for (String name : permissionGroups.keySet())
				{
					%>
					<th class="columnheader" colspan="2"><b><%=name%></b></th>
					<%
				}
				%>
				</tr>
				<%
				int newItems = 0;
				int index = 0;
				int i = 0;
				do
				{
					newItems = 0;
					StringBuilder sb = new StringBuilder();
					sb.append("<tr valign=\"top\"");
					sb.append(" class=\"").append(i == 1 ? "oddrow" : "evenrow").append("\"");
					sb.append(">");
					for (String name : permissionGroups.keySet())
					{
						List<Item> items = permissionGroups.get(name);
						if (items.size() > index)
						{
							newItems++;
							Item item = items.get(index);
							int keyId = SystemItems.getRoleKeyId(item);
							RoleKey key = RoleKey.getById(dc, keyId);
							
							sb.append("<td class=\"cell\"><b>").append(key.getName()).append("</b></td>");
							sb.append("<td class=\"cell\">");
														
							if (keyId != 0)
							{								
								Set<Permission> permissions = key.getPermissions(role);
								sb.append(getShortPermissions(item, permissions));
							}
							else
							{
								sb.append("(undefined key)");
							}
							sb.append("</td>");
						}
						else
						{
							sb.append("<td class=\"cell\" colspan=\"2\">&nbsp;</td>");
						}
					}
					if (newItems > 0)
					{
						%>
						<%=sb.toString()%>
						<%
					}
					i = 1 - i;
					index++;
				} while (newItems > 0);
				%>
				<tr class="panel">
				<td colspan="99" class="panel">
				<b>C</b> = Create, <b>R</b> = Read, <b>U</b> = Use, 
				<b>W</b> = Write, <b>D</b> = Delete, <b>O</b> = Change owner, <b>P</b> = Change permissions
				
				</td>
				</tr>
				</table>
				</div>
				</div>				
				<br>
			</base:section>
			<%
			ItemQuery<User> userQuery = role.getUsers();
			userQuery.include(Include.ALL);
			userQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<User> users = userQuery.list(dc);
			
			if (users.size() == 0)
			{
				%>
				<h4>Members</h4>
				There are no members of this role (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="members" 
					title="<%="Members (" + users.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="members"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="type"
						title="Type"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (User user : users)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="type">User</tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(user.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this role" />
			</jsp:include>

		</div>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
