<%-- $Id: options.jsp 5813 2011-10-18 09:24:06Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Presets"
	import="net.sf.basedb.core.Presets.Preset"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
	import="net.sf.basedb.util.overview.Node"
	import="net.sf.basedb.util.overview.ValidationOptions"
	import="net.sf.basedb.util.overview.Severity"
	import="net.sf.basedb.util.overview.Validator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
final String presetName = Values.getStringOrNull(request.getParameter("presetName"));
final boolean resetToDefault = Values.getBoolean(request.getParameter("resetToDefault"));
try
{
	Presets presets = OverviewUtil.getValidationPresets(sc);
	ValidationOptions options = null;
	if (resetToDefault)
	{
		options = new ValidationOptions();
	}
	else if (presetName == null)
	{
		options = new ValidationOptions(presets.getDefault());
	}
	else
	{
		options = new ValidationOptions(presets.getPreset(presetName));
	}
	Map<String, List<Validator>> validators = OverviewUtil.getValidators();
	%>
	<base:page title="Validation options" type="popup">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
	<script language="JavaScript">
	function saveOptions()
	{
		document.forms['options'].submit();
	}
	function toggle(grpId)
	{
		var grp = document.getElementById('grp.'+grpId);
		var grpIcon = document.getElementById('grp.'+grpId+'.icon');
		var vldId = 1;
		var vld = document.getElementById('vld.'+grpId+'.'+vldId);
		if (vld && vld.style.display == 'none')
		{
			grpIcon.src = getRoot()+'images/joust/minustop.gif';
		}
		else
		{
			grpIcon.src = getRoot()+'images/joust/plusonly.gif';
		}
		while (vld)
		{
			Main.showHide(vld.id);
			vldId++;
			vld = document.getElementById('vld.'+grpId+'.'+vldId);
		}
	}
	function setAllInGroup(grpId, severity)
	{
		var vldId = 1;
		var vld = document.getElementById('select.'+grpId+'.'+vldId);
		while (vld)
		{
			for (var i = 0; i < vld.length; i++)
			{
				if (vld[i].value == severity) 
				{
					vld.selectedIndex = i;
					i = vld.length;
				}
			}
			vldId++;
			vld = document.getElementById('select.'+grpId+'.'+vldId);
		}
	}
	function setAllOnChange(grpId, selectList)
	{
		var severity = selectList[selectList.selectedIndex].value;
		selectList.selectedIndex = 0;
		setAllInGroup(grpId, severity);
	}
	
	function showDescription(evt, validatorId)
	{
		var description = 'description.'+validatorId;
		Main.show(description);
		var el = document.getElementById(description);
		el.style.left = (evt.clientX + 10) + 'px';
		el.style.top = (evt.clientY - 10) + 'px';
	}
	function hideDescription(validatorId)
	{
		var description = 'description.'+validatorId;
		Main.hide(description);
	}
	function presetsOnChange()
	{
		var frm = document.forms['options'];
		var selected = frm.presets[frm.presets.selectedIndex].value;
		if (selected == '')
		{
			location.href = 'options.jsp?ID=<%=ID%>&resetToDefault=1';
		}
		else if (selected != '---')
		{
			location.href = 'options.jsp?ID=<%=ID%>&presetName='+encodeURIComponent(selected);
		}
	}
	function saveAsOnClick()
	{
		Main.openPopup('save_preset.jsp?ID=<%=ID%>', 'SaveValidationPreset', 480, 200);
	}
	function saveAsPreset(name)
	{
		var frm = document.forms['options'];
		frm.cmd.value = 'SaveAsPreset';
		Forms.createHidden(frm, 'presetName', name);
		frm.submit();
	}
	function removeOnClick()
	{
		var frm = document.forms['options'];
		var selected = frm.presets[frm.presets.selectedIndex].value;
		if (selected != '---' && selected != '')
		{
			if (confirm('Remove preset: \'' + selected + '\'? This can\'t be undone.'))
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=RemovePreset&presetName='+escape(selected);
			}
		}
	}
	</script>
	</base:head>
		<base:body>
		
		<form name="options" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SaveValidationOptions">
		
		<h3 class="docked">Validation options <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom">
		<t:tab id="options" title="Validation options" helpid="item.overview.validationoptions">
		
			<table border="0" cellspacing="0" cellpadding="0">
			<tr>
			<td style="border-bottom: 1px solid #999999;"><b>Presets</b></td>
			<td style="border-bottom: 1px solid #999999; padding-bottom: 4px;">
				<select name="presets" onchange="presetsOnChange()">
					<option value="---" class="selectoptionheader">-- predefined --
					<option value="" <%="".equals(presetName) ? "selected" : "" %>>BASE default
					<option value="---" class="selectoptionheader">-- user defined --
					<%
					for (Preset preset : presets)
					{
						String name = HTML.encodeTags(preset.getName());
						String selected = presetName != null && presetName.equals(preset.getName()) ?
							"selected" : "";
						%>
						<option value="<%=name%>" <%=selected%>><%=name%>
						<%					
					}
					%>
				</select>
			</td>
			<td style="border-bottom: 1px solid #999999; padding-left: 4px; padding-bottom: 4px;"><base:button title="Save as&hellip;" onclick="saveAsOnClick()" /></td>
			<td style="border-bottom: 1px solid #999999; padding-left: 4px; padding-bottom: 4px;"><base:button title="Remove&hellip;" onclick="removeOnClick()" /></td>
			</tr>
			<%
			int grp = 0;
			StringBuilder descriptions = new StringBuilder();
			for (Map.Entry<String, List<Validator>> entry : validators.entrySet())
			{
				String title = entry.getKey();
				++grp;
				int vld = 0;
				%>
				<tr id="grp.<%=grp%>">
					<td style="padding-top: 6px;"><a href="javascript:toggle(<%=grp%>)"
						><base:icon id="<%="grp."+grp+".icon"%>" 
							image="joust/plusonly.gif" 
						/>&nbsp;<b><%=HTML.encodeTags(title)%></b></a>&nbsp;&nbsp;
					</td>
					<td style="padding-top: 6px;" colspan="3">
						<select name="setall.<%=grp%>" onchange="setAllOnChange(<%=grp%>, this)">
						<option value="">- set all in this group -
						<%
						for (Severity s : Severity.values())
						{
							%>
							<option value="<%=s.name()%>"><%=s%>
							<%
						}
						%>
					</td>
				</tr>
				<%
				Iterator<Validator> vi = entry.getValue().iterator();
				while (vi.hasNext())
				{
					Validator validator = vi.next();
					++vld;
					Severity option = options.getSeverity(validator);
					String validatorId = validator.getId();
					boolean hasNext = vi.hasNext();
					descriptions.append("<div id=\"description.").append(validatorId).append("\"");
					descriptions.append(" class=\"postit\" style=\"display:none;\">");
					descriptions.append(HTML.encodeTags(validator.getDescription()));
					descriptions.append("</div>\n");
					%>
					<tr id="vld.<%=grp%>.<%=vld%>" style="display: none;"
						>
						<td
							onmouseover="showDescription(event, '<%=validatorId%>')"
							onmouseout="hideDescription('<%=validatorId%>')"
							><base:icon 
							image="<%=hasNext ? "joust/big/join.gif" : "joust/big/joinbottom.gif"%>" 
							/><%=HTML.encodeTags(validator.getTitle())%>&nbsp;&nbsp;</td>
						<td colspan="3">
						<select id="select.<%=grp%>.<%=vld%>" name="<%=validatorId%>">
							<%
							for (Severity s : Severity.values())
							{
								%>
								<option value="<%=s.name()%>" <%=s == option ? "selected" : "" %>><%=s%>
								<%
							}
							%>
						</select>
						<%
						if (validator == Validator.NONMATCHING_SPOTCOUNT)
						{
							%>
							Threshold:
							<input type="text" class="text" 
								name="threshold" 
								title="Threshold, as a percentage or an absolute value" 
								size="8"
								value="<%=HTML.encodeTags(options.getOption(validator, "threshold", "5%"))%>" >
							<%
						}
						%>
						</td>
					</tr>
					<%
				}
			}
			%>
			</table>
			<%=descriptions.toString()%>	
		</t:tab>
		</t:tabcontrol>
		
		<div align="center">
		<table>
		<tr>
			<td width="50%"><base:button title="Save" onclick="saveOptions()"/></td>
			<td width="50%"><base:button title="Cancel" onclick="window.close()"/></td>
		</tr>
		</table>
		</div>
		
		</form>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
