<%-- $Id: configure.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.PluginParameter"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.LongParameterType"
	import="net.sf.basedb.core.FloatParameterType"
	import="net.sf.basedb.core.DoubleParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.DateParameterType"
	import="net.sf.basedb.core.TimestampParameterType"
	import="net.sf.basedb.core.BooleanParameterType"
	import="net.sf.basedb.core.FileParameterType"
	import="net.sf.basedb.core.PathParameterType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Arrays"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String clazz = "class=\"text\"";
final String requiredClazz = "class=\"text required\"";

final Item itemType = request.getParameter("item_type") == null ? null : Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext currentContext = itemType == null ? null : sc.getCurrentContext(itemType, subContext);
DbControl dc = null;
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String jsDateTimeFormat = HTML.javaScriptEncode(dateTimeFormat);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);

	dc = sc.newDbControl();
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	if (pcRequest == null) throw new WebException("popup", "No request information found", "No request information found");
	
	PluginDefinition plugin = (PluginDefinition)sc.getSessionSetting("plugin.configure.plugin");
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(plugin, false);
	boolean configureByExample = false;
	PluginConfiguration pluginConfig = (PluginConfiguration)sc.getSessionSetting("plugin.configure.config");
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	RequestInformation ri = pcRequest.getRequestInformation();
	List<PluginParameter<?>> parameters =  ri.getParameters();
	String title = HTML.encodeTags(ri.getTitle());
	String jobName = Values.getString(request.getParameter("job_name"), title);
	StringBuilder sb = new StringBuilder();
	String helpText = ri.getDescription();
	if (helpText == null && pluginConfig != null) helpText = pluginConfig.getDescription();
	if (helpText == null) helpText = plugin.getDescription();
	List<File> recentFiles = null;
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="plugin.js,parameters.js,ajax.js,json2.js" styles="parameters.css">
		<script language="JavaScript">
		function init()
		{
			var width = Main.getWindowWidth();
			var height = Main.getWindowHeight();
			if (height < 600) height = 600;
			if (width < 800) width = 800; // >
			window.resizeTo(width, height);
			<%
			if (parameters != null && parameters.size() > 0)
			{
				for (PluginParameter<?> param : parameters)
				{
					ParameterType pType = param.getParameterType();
					String name = param.getName();
					if ("parserSection".equals(name)) 
					{
						configureByExample = plugin.supports("net.sf.basedb.util.parser.ConfigureByExample");
					}
					String label = HTML.encodeTags(Values.trimString(param.getLabel(), 30));
					String fullLabel = HTML.encodeTags(param.getLabel());
					if (pType != null)
					{
						// Get the current values... First we look in the http request object...
						String[] requestValues = request.getParameterValues("parameter:"+param.getName());
						// ...or in the current values from the job / plugin configuration
						List values = requestValues != null ? Arrays.asList(requestValues) : pcRequest.getCurrentParameterValues(param.getName());
						// File parameters should also check the auto-detected-file (if not enumeration)
						if ((values == null || values.size() == 0) && !pType.isEnumeration() && 
							pType instanceof FileParameterType)
						{
							if (currentContext != null && currentContext.getObject("auto-detected-file") != null)
							{
								values =  Collections.singletonList(currentContext.getObject("auto-detected-file"));
								currentContext.setObject("auto-detected-file", null);
							}
						}
						// Then, we check the parameters default value
						if ((values == null || values.size() == 0) && param.getDefaultValue() != null)
						{
							values = Collections.singletonList(param.getDefaultValue());
						}
						// Item and File parameters will also look in the current context unless they are enumerated
						if ((values == null || values.size() == 0) && 
							!pType.isEnumeration() &&
							(pType instanceof ItemParameterType || pType instanceof FileParameterType))
						{
							Item parameterItemType = Item.fromClass(pType.getParameterClass());
							ItemContext cc = sc.getCurrentContext(parameterItemType, parameterItemType == itemType ? subContext : "");
							if (cc.getId() != 0 && pType.getMultiplicity() == 1)
							{
								values = new java.util.ArrayList();
								if (pType instanceof FileParameterType)
								{
									try
									{
										values.add(File.getById(dc, cc.getId()).getPath().toString());
									}
									catch (Throwable t)
									{}
									if (currentContext != null && recentFiles == null)
									{
										recentFiles = (List<File>)currentContext.getRecent(dc, Item.FILE);
									}
								}
								else
								{
									values.add(cc.getId());
								}
							}
							else if (cc.getSelected().size() > 0 && pType.getMultiplicity() != 1)
							{
								values = new java.util.ArrayList(cc.getSelected());
							}
						}
						// Finally, if the parameter has multiplicity=1, is requried and has a list of enumeration values
						if ((values == null || values.size() == 0) && pType.getNotNull() && 
							pType.getMultiplicity() == 1 && pType.getItems() != null && pType.getItems().size() > 0)
						{
							values = Collections.singletonList(pType.getItems().get(0));	
						}
						%>
						var values = new Array();
						<%
						int numNotNullValues = 0;
						if (values != null && values.size() > 0)
						{
							for (Object value : values)
							{
								if (value instanceof Date) 
								{
									if (pType.isEnumeration())
									{
										value = ((Date)value).getTime();
									}
									else
									{
										if (pType.getValueType() == Type.TIMESTAMP)
										{
											value = dateTimeFormatter.format((Date)value);
										}
										else
										{
											value = dateFormatter.format((Date)value);
										}
									}
								}
								else if (value instanceof File && pType instanceof FileParameterType)
								{
									File file = File.getById(dc, ((File)value).getId());
									value = file.getPath().toString();
								}
								else if (value instanceof BasicItem)
								{
									value = ((BasicItem)value).getId();
								}
								if (value != null)
								{
									numNotNullValues++;
									%>
									values[values.length] = '<%=HTML.javaScriptEncode(value.toString())%>';
									<%
								}
							}
						}
						%>
						new Parameter('<%=name%>', '<%=HTML.javaScriptEncode(param.getLabel())%>', <%=pType.getMultiplicity()%>, <%=pType.isEnumeration()%>, <%=pType.getNotNull()%>, values);
						<%
						String icon = "";
						if (numNotNullValues > 0)
						{
							icon = pType.getNotNull() ? "required_values.gif" : "notrequired_values.gif";
						}
						else
						{
							icon = pType.getNotNull() ? "required_novalues.gif" : "notrequired_novalues.gif";
						}
						if (!param.isHidden())
						{
							icon = "<span class=\"icon\"><img id=\"icon_"+name+"\" src=\"../../images/"+icon+"\"></span>";
							sb.append("<div class=\"param\" id=\"prompt_"+name+"\" onclick=\"parametersOnClick('"+name+"')\"");
							sb.append(" title=\""+fullLabel+"\">");
							sb.append(icon+"<span class=\"label\">"+label+"</span></div>\n");
						}
					}
					else
					{
						sb.append("<h4 class=\"param\" id=\"prompt_"+name+"\" title=\""+fullLabel+"\" onclick=\"parametersOnClick('"+name+"')\">"+label+"</h4>");
						%>
						new Parameter('<%=name%>', '[<%=HTML.javaScriptEncode(param.getLabel())%>]', 1, 0, 0, {});
						<%
					}
				}
			}
			%>
		}
		
		var oldValueDiv;
		function parametersOnClick(parameterId)
		{
			var frm = document.forms['configure'];
			if (oldValueDiv) Main.hide(oldValueDiv);
			
			var pp = Parameters.allParameters['ID'+parameterId];
			setSelectedParameter(pp, parameterId);
			oldValueDiv = 'value_'+pp.name+'_div'
			Main.show(oldValueDiv);
			var valueElement = frm['value_'+pp.name];
			if (valueElement.focus && !valueElement.disabled) valueElement.focus();
			if (pp.enumeration)
			{
				Main.hide('valuecontainer');
				var numSelected;
				if (valueElement.type && valueElement.type.search('select') != -1)
				{
					numSelected = Forms.selectListOptions(valueElement, pp.values);
				}
				else if (pp.multiplicity == 1)
				{
					// radio buttons
					numSelected = Forms.checkRadio(valueElement, pp.values[0]) == -1 ? 0 : 1;
				}
				else
				{	
					// check boxes
					numSelected = Forms.checkCheckBoxes(valueElement, pp.values);
				}
				if (numSelected == 0)
				{
					pp.values.length = 0;
					updateSelectedStyle();
				}
			}
			else if (pp.multiplicity == 1)
			{
				Main.hide('valuecontainer');
				var currentValue = pp.values.length > 0 ? pp.values[0] : '';
				if (valueElement.length) // ie. radio buttons for boolean parameter
				{
					Forms.checkRadio(valueElement, currentValue);
				}
				else if (!valueElement.disabled)
				{
					valueElement.value = currentValue;
				}
			}
			else
			{
				var values = frm.values;
				values.length = 0;
				for (var i = 0; i < pp.values.length; i++) // >
				{
					var value = Main.cutString(pp.values[i].replace(/\n/g, ' '), 40);
					values[values.length] = new Option(value);
				}
				var mult = document.getElementById('multiplicity');
				mult.innerHTML = pp.multiplicity == 0 ? '' : '(Max '+pp.multiplicity+' values)';
				Main.show('valuecontainer');
			}
		}
		
		var selectedPluginParameter = null;
		var selectedPluginParameterId = null;
		function getSelectedParameter()
		{
			return selectedPluginParameter;
		}
		
		function setSelectedParameter(pluginParameter, parameterId)
		{
			if (selectedPluginParameter != null)
			{
				Main.removeClass(document.getElementById('prompt_'+selectedPluginParameter.name), 'selected');
			}
			selectedPluginParameter = pluginParameter;
			selectedPluginParameterId = parameterId;
			if (selectedPluginParameter != null)
			{
				Main.addClass(document.getElementById('prompt_'+selectedPluginParameter.name), 'selected');
			}
		}

		function updateStyle(pp)
		{
			var icon = document.getElementById('icon_'+pp.name);
			var gif = getRoot()+'images/';
			if (pp.values.length == 0)
			{
				gif += pp.required ? 'required_novalues.gif' : 'notrequired_novalues.gif';
			}
			else
			{
				gif += pp.required ? 'required_values.gif' : 'notrequired_values.gif';
			}
			icon.src = gif;
		}

		function updateSelectedStyle()
		{
			updateStyle(getSelectedParameter());
		}
		
		function setCurrentValue(value)
		{
			var pp = getSelectedParameter();
			if (value == null || value == '')
			{
				pp.removeValue(0);
			}
			else
			{
				pp.updateValue(0, value);
			}
			updateSelectedStyle();
		}
		
		function setEnumValues(inputName)
		{
			var pp = getSelectedParameter();
			if (!pp) return;
		
			var frm = document.forms['configure'];
			var valueElement = frm[inputName];
			var values = new Array();
			for (var i = 0; i < valueElement.length; i++) // >
			{
				if (valueElement[i].checked || valueElement[i].selected) 
				{
					values[values.length] = valueElement[i].value;
				}
			}
			pp.setValues(values);
			updateSelectedStyle();
		}

		var lastValueIndex = -1;
		function valuesOnClick()
		{
			var frm = document.forms['configure'];
			var pp = getSelectedParameter();
			lastValueIndex = frm.values.selectedIndex;
			if (lastValueIndex >= 0)
			{
				frm['value_'+pp.name].value = pp.values[lastValueIndex];
			}
		}

		function valueOnBlur(value)
		{
			var pp = getSelectedParameter();
			if (!pp) return;
			if (pp.multiplicity == 1) 
			{
				setCurrentValue(value);
			}
			else
			{
				if (lastValueIndex < 0) return; // >
				var frm = document.forms['configure'];
				if (value == '' || value == null)
				{
					pp.removeValue(lastValueIndex);
					frm.values[lastValueIndex] = null;
				}
				else
				{
					pp.updateValue(lastValueIndex, value);
					frm.values[lastValueIndex].text = value;
				}
			}
		}
		function addOnClick()
		{
			var pp = getSelectedParameter();
			if (!pp) return; 
			var frm = document.forms['configure'];
			var valueElement = frm['value_'+pp.name];
			if (frm.values.selectedIndex < 0 && valueElement.value != '') // >
			{
				if (pp.addValue(valueElement.value))
				{
					lastValueIndex = frm.values.length;
					frm.values[lastValueIndex] = new Option(valueElement.value, '', false, false);
					valueElement.value = '';
					lastValueIndex = -1;
				}
			}
			else
			{
				if (pp.addValue(''))
				{
					lastValueIndex = frm.values.length;
					frm.values[lastValueIndex] = new Option('<new>', '', false, true);
					valueElement.value = '';
				}
			}
			valueElement.focus();
			updateSelectedStyle();
		}
		function removeOnClick()
		{
			var pp = getSelectedParameter();
			if (!pp) return;
			
			var frm = document.forms['configure'];
			var values = frm.values;
			for (var i = 0; i < values.length; i++) // >
			{
				if (values[i].selected)
				{
					pp.removeValue(i);
					values[i] = null;
					i--;
				}
			}
			updateSelectedStyle();
		}
		
		function selectAll(inputName)
		{
			var frm = document.forms['configure'];
			var list = frm[inputName];
			if (list.length == 0) return;
			var select = !list[0].selected;;
			for (var i = 0; i < list.length; i++)
			{
				list[i].selected = select;
			}
			setEnumValues(inputName);
		}
		
		function setDateCallback(frmName, inputName, theDate)
		{
			var frm = document.forms[frmName];
			frm[inputName].value = theDate;
			valueOnBlur(theDate);
		}
		var lastFileInputName;
		function browseOnClick(inputName)
		{
			var frm = document.forms['configure'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
			lastFileInputName = inputName;
			Main.openPopup(url, 'SelectFile', 1000, 700);
		}
		function setFileCallback(fileId, path, inputName)
		{
			var frm = document.forms['configure'];
			if (!inputName) inputName = lastFileInputName;
			frm[inputName].value = path;
			valueOnBlur(path);
			if (Parameters.allParameters['ID<%=Parameters.CHARSET_PARAMETER%>']) updateCharset(fileId);
		}
		function updateCharset(fileId)
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = '../../filemanager/files/ajax.jsp?ID=<%=ID%>&cmd=GetFileInfo&item_id=' + fileId;
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateCharsetCallback);
				request.send(null);
			}
			return request != null;
		}
		function updateCharsetCallback(request)
		{
			var response = Ajax.parseJsonResponse(request.responseText);
			var charset = response.characterSet;
			if (charset)
			{
				setParameterValue('<%=Parameters.CHARSET_PARAMETER%>', charset);
			}
		}
		function recentOnChange(inputName)
		{
			var frm = document.forms['configure'];
			var recentList = frm['recent.'+inputName];
			var path = recentList[recentList.selectedIndex].text;
			var fileId = recentList[recentList.selectedIndex].value;
			setFileCallback(fileId, path, inputName);
			recentList.selectedIndex = 0;
		}
		
		var lastItemInputName;
		function selectItemOnClick(inputName, itemType)
		{
			lastItemInputName = inputName;
			Main.selectItem('<%=ID%>', itemType, 'selectone', 'selectItemCallback');
		}
		function selectItemCallback(itemId, name)
		{
			var frm = document.forms['configure'];
			frm[lastItemInputName].value = name;
			setCurrentValue(itemId);
		}
		function clearItemOnClick(inputName, itemType)
		{
			var frm = document.forms['configure'];
			frm[inputName].value = '';
			setCurrentValue();
		}
		
		function saveAsOnClick(inputName)
		{
			var frm = document.forms['configure'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SaveAs&callback=saveAsCallback';
			lastFileInputName = inputName;
			var i = frm[inputName].value.lastIndexOf('/');
			if (i >= 0) 
			{
				url += '&fileName=' + encodeURIComponent(frm[inputName].value.substring(i+1));
			}
			Main.openPopup(url, 'SaveAs', 1000, 700);
		}
		function saveAsCallback(path)
		{
			var frm = document.forms['configure'];
			frm[lastFileInputName].value = path;
			valueOnBlur(path);
		}
		function selectDirectoryOnClick(inputName)
		{
			var frm = document.forms['configure'];
			var url = '../../filemanager/directories/index.jsp?ID=<%=ID%>&mode=selectonedirectory&callback=setFileCallback';
			lastFileInputName = inputName;
			Main.openPopup(url, 'SelectDirectory', 350, 500);
		}
		
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}
		function toggleStacktrace(index)
		{
			Main.showHide('stacktrace.' + index);
			var img = document.getElementById('stacktracelink.'+index);
			if (img.src.indexOf('show_section') > 0)
			{
				img.src = getRoot() + '/images/hide_section.gif';
			}
			else
			{
				img.src = getRoot() + '/images/show_section.gif';
			}
		}
		function saveSettings()
		{
			var frm = document.forms['configure'];
			for (var i = 0; i < Parameters.allParameters.length; i++) // > 
			{
				var pp = Parameters.allParameters[i];
				if (pp.required && pp.values.length == 0)
				{
					alert('No value entered for parameter '+pp.label);
					return;
				}
			}
			Parameters.addParameterValuesToForm(frm);
			//Main.openPopup('', 'SubmitPluginParameters', 100, 100);
			//frm.target = 'SubmitPluginParameters';
			frm.submit();
		}
		
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		
		function testWithFile()
		{
			Main.openPopup('test_with_file.jsp?ID=<%=ID%>', 'TestWithFile', 1000, 800);
		}
		
		function getParameterValue(ID)
		{
			var param = Parameters.allParameters['ID'+ID];
			if (param)
			{
				return param.values;
			}
			else
			{
				return '';
			}
		}
		
		function setParameterValue(ID, value)
		{
			var param = Parameters.allParameters['ID'+ID];
			if (param)
			{
				if (value == null || Main.trimString(value) == '')
				{
					param.clearValues();
				}
				else
				{
					var values = new Array();
					values[values.length] = value;
					param.setValues(values);
				}
				var selected = getSelectedParameter();
				if (selected && selected.name == param.name)
				{
					parametersOnClick(param.name);
				}
				updateStyle(param);
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="configure" onsubmit="return false;">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="title" value="<%=title%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<%
		if (itemType != null)
		{
			%>
			<input type="hidden" name="item_type" value="<%=itemType.name()%>">
			<%
		}
		%>
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		
		<h3 class="docked"><%=title%> <base:help 
			helpid="<%="runplugin.configure"+(job != null ? "." + plugin.getMainType().name().toLowerCase() : "") %>" /></h3>
		<div class="boxed">
		
			<table class="form">
			<tr valign="baseline">
				<td class="prompt">Plugin</td>
				<td><%=plugin == null ? "<i>- none -</i>" : HTML.encodeTags(plugin.getName())%></td>
				<td class="prompt">Configuration</td>
				<td><%=pluginConfig == null ? "<i>- none -</i>" : HTML.encodeTags(pluginConfig.getName())%></td>
			</tr>
			</table>
		
			<div class="pluginhelp">
				<%=HTML.niceFormat(helpText)%>
			</div>

			<table class="form" cellspacing="0" border="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td nowrap style="width: 240px">
					<div class="parameterlist" style="height: <%=(int)(scale*320)%>px; width:240px;">
					<%=sb.toString()%>
					</div>
					<base:icon image="hasvalues.gif" /> = has value(s), <base:icon image="required.gif" /> = required
				</td>
				
				<td>
					<%
					if (errorMessage != null || (errors != null && errors.size() > 0))
					{
						%>
						<div id="errors" style="margin-bottom: 12px;" class="parameterhelp">
							<div class="error" style="margin: 0px;">
							<%=errorMessage %>
							</div>
							<%
							if (errors != null && errors.size() > 0)
							{
								%>
								<div id="showerrorlist" style="display: none;">
									<base:icon image="bullet.gif" /><a href="javascript:showErrorList()">Show</a>
								</div>
								<div id="errorlist">
								<ol>
								<%
								int i = 0;
								java.io.PrintWriter pw = new java.io.PrintWriter(out);
								for (Throwable t : errors)
								{
									++i;
									t.printStackTrace();
									StackTraceElement[] st = t.getStackTrace();
									%>
									<li><%=t.getMessage()%><br>
										<base:icon 
											image="show_section.gif" 
											onclick="<%="toggleStacktrace(" + i + ")"%>" 
											tooltip="Toggle display of detailed stacktrace"
											id="<%="stacktracelink." + i %>"
											style="float: left;"
										/>
										<div id="stacktrace.<%=i%>" style="display:none; font-size: smaller; position: relative; left: 1em; top: -1em; overflow: auto;">
										<%
										out.print("<pre>");
										while (t != null)
										{
											out.println(t.toString());
											for (int index = 0; index < st.length; ++index)
											{
												out.print("...at ");
												out.println(st[index].toString());
											}
											t = t.getCause();
											if (t != null) out.print("\nCaused by: ");
										}
										out.print("</pre></div>");
									}
									%>
								</ol>
								<base:icon image="bullet.gif" /><a href="javascript:hideErrorList()">Hide all</a>
								</div>
								<%
							}
							%>
						</div>
						<%
					}
					%>
				
					<div id="valuecontainer" style="display: none;">
					<table cellspacing="2" border="0" cellpadding="0" cellspacing="0">
						<tr valign="top">
						<td>
							<b>Values</b> <span id="multiplicity"></span><br>
							<select name="values" size="5" style="width: 20em;"
								onchange="valuesOnClick()" multiple>
							</select>
						</td>
						<td>&nbsp;</td>
						<td>
						<td>
							<br>
							<base:button onclick="addOnClick()" title="Add" />
							<base:button onclick="removeOnClick()" title="Remove" />
						</td>
					</table>
					</div>

					<%
					if (parameters != null && parameters.size() > 0)
					{
						for (PluginParameter<?> param : parameters)
						{
							if (!param.isHidden())
							{
								ParameterType pType = param.getParameterType();
								String inputName = "value_"+param.getName();
								if (pType != null)
								{
									int multiplicity = pType.getMultiplicity();
									String select = null;
									if (multiplicity == 0)
									{
										if (pType.getNotNull())
										{
											select = "Select one or more";
										}
										else
										{
											select = "Select zero or more";
										}
									}
									else if (multiplicity == 1)
									{
										select = "Select one";
									}
									else
									{
										if (pType.getNotNull())
										{
											select = "Select 1 -- " + multiplicity;
										}
										else
										{
											select = "Select 0 -- " + multiplicity;
										}
									}
									%>
									<div id="<%=inputName%>_div" style="display: none;">
									<%
									if (pType.isEnumeration())
									{
										Enumeration<?, String> enumeration = pType.getEnumeration();
										List<?> values = pType.getItems();
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (<%=select%>)
										<%
										if (multiplicity != 1)
										{
											%>
											<base:icon image="check_uncheck.gif" 
												tooltip="Select/deselect all" onclick="<%="selectAll('" + inputName + "')"%>"/>
											<%
										}
										%>
										<br>
										<%
										if (multiplicity == 1)
										{
											%>
											<select name="<%=inputName%>"
												onchange="setCurrentValue(this[this.selectedIndex].value)">
											<%
											if (!pType.getNotNull())
											{
												%>
												<option value="" style="font-style: italic;">- not specified -
												<%
											}
										}
										else
										{
											%>
											<select name="<%=inputName%>" multiple size="10" style="width: 30em;"
												onchange="setEnumValues('<%=inputName%>')">
											<%
										}
										for (int i = 0; i < values.size(); ++i)
										{
											Object value;
											String listValue = "";
											String listText = "";
											String listTitle = "";
											if (enumeration != null)
											{
												value = enumeration.getKey(i);
												listText = HTML.encodeTags(enumeration.getValue(i));
											}
											else
											{
												value = values.get(i);
											}
											if (value instanceof Date) 
											{
												listValue = Long.toString(((Date)value).getTime());
												if (enumeration == null) 
												{
													if (pType.getValueType() == Type.TIMESTAMP)
													{
														listText = dateTimeFormatter.format((Date)value);
													}
													else
													{
														listText = dateFormatter.format((Date)value);
													}
												}
											}
											else if (value instanceof BasicItem)
											{
												BasicItem item = (BasicItem)value;
												listValue = Integer.toString(item.getId());
												if (item instanceof Nameable)
												{
													Nameable nameable = (Nameable)item;
													if (enumeration == null) listText = HTML.encodeTags(nameable.getName());
													listTitle = HTML.encodeTags(nameable.getDescription());
												}
												else
												{
													if (enumeration == null) listText = HTML.encodeTags(item.toString());
												}
											}
											else
											{
												listValue = HTML.encodeTags(value == null ? "" : value.toString());
												if (enumeration == null) listText = listValue;
											}
											%>
											<option value="<%=listValue%>" title="<%=listTitle%>"><%=listText%>
											<%
										}
										%>
										</select>
										<%
									}
									else if (pType instanceof StringParameterType)
									{
										Integer maxLength = ((StringParameterType)pType).getMaxLength();
										int width = pType.getWidth() <= 0 ? 40 : pType.getWidth();
										if (width > 80) width = 80;
										int height = pType.getHeight() <= 0 ? 6 : pType.getHeight();
										if (height > 20) height = 20;
										if (maxLength == null || maxLength > 255)
										{
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Text)<br>
											<textarea <%=pType.getNotNull() ? requiredClazz : clazz%> 
												name="<%=inputName%>" rows="<%=height%>" cols="<%=width%>"
												onblur="valueOnBlur(this.value)"></textarea>
											<a href="javascript:Main.zoom('<%=HTML.javaScriptEncode(param.getLabel())%>', 'configure', '<%=inputName%>')" 
												title="Edit in larger window"><base:icon image="zoom.gif" /></a>
											<%
										}
										else
										{
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (String)<br>
											<input <%=pType.getNotNull() ? requiredClazz : clazz%> type="text" 
												name="<%=inputName%>" value=""
												size="<%=width%>" maxlength="<%=maxLength%>"
												onblur="valueOnBlur(this.value)">
											<%
										}
									}
									else if (pType instanceof IntegerParameterType)
									{
										IntegerParameterType ipType = (IntegerParameterType)pType;
										Integer minValue = ipType.getLowerLimit();
										Integer maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Integer<%=minMax%>)<br>
										<input <%=pType.getNotNull() ? requiredClazz : clazz%>
											type="text" name="<%=inputName%>" value=""
											size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)"
											onblur="valueOnBlur(this.value)">
										<%
									}
									else if (pType instanceof LongParameterType)
									{
										LongParameterType ipType = (LongParameterType)pType;
										Long minValue = ipType.getLowerLimit();
										Long maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Long<%=minMax%>)<br>
										<input <%=pType.getNotNull() ? requiredClazz : clazz%>
											type="text" name="<%=inputName%>" value=""
											size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)"
											onblur="valueOnBlur(this.value)">
										<%
									}
									else if (pType instanceof FloatParameterType)
									{
										FloatParameterType ipType = (FloatParameterType)pType;
										Float minValue = ipType.getLowerLimit();
										Float maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Float<%=minMax%>)<br>
										<input <%=pType.getNotNull() ? requiredClazz : clazz%>
											type="text" name="<%=inputName%>" value=""
											size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)"
											onblur="valueOnBlur(this.value)">
										<%
									}
									else if (pType instanceof DoubleParameterType)
									{
										DoubleParameterType ipType = (DoubleParameterType)pType;
										Double minValue = ipType.getLowerLimit();
										Double maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Double<%=minMax%>)<br>
										<input <%=pType.getNotNull() ? requiredClazz : clazz%>
											type="text" name="<%=inputName%>" value=""
											size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)"
											onblur="valueOnBlur(this.value)">
										<%
									}
									else if (pType instanceof DateParameterType)
									{
										%>
										<table>
										<tr>
										<td>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Date)<br>
											<input <%=pType.getNotNull() ? requiredClazz : clazz%>
												type="text" name="<%=inputName%>" value=""
												size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"
												onblur="valueOnBlur(this.value)">
										</td>
										<td>
											<br>
											<base:button 
												onclick="<%="Dates.selectDate('Value', 'configure', '"+inputName+"', 'setDateCallback', '"+jsDateFormat+"')"%>" 
												image="calendar.png"
												title="Calendar&hellip;" 
												tooltip="Select a date from a calendar" 
											/>
										</td>
										</tr>
										</table>
										<%
									}
									else if (pType instanceof TimestampParameterType)
									{
										%>
										<table>
										<tr>
										<td>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Timestamp)<br>
											<input <%=pType.getNotNull() ? requiredClazz : clazz%>
												type="text" name="<%=inputName%>" value=""
												size="20" maxlength="20" title="Enter timestamp in format: <%=htmlDateTimeFormat%>"
												onblur="valueOnBlur(this.value)">
										</td>
										<td>
											<br>
											<base:button 
												onclick="<%="Dates.selectDateTime('Value', 'configure', '"+inputName+"', 'setDateCallback', '"+jsDateTimeFormat+"')"%>" 
												image="calendar.png"
												title="Calendar&hellip;" 
												tooltip="Select a timestamp from a calendar" 
											/>
										</td>
										</tr>
										</table>
										<%
									}
									else if (pType instanceof BooleanParameterType)
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<input type="radio" name="<%=inputName%>" id="<%=inputName%>.null" value="" checked
											onclick="setCurrentValue(null)"><label for="<%=inputName%>.null"><i>- not specified -</i></label><br>
										<input type="radio" name="<%=inputName%>" id="<%=inputName%>.true" value="true" 
											onclick="setCurrentValue('true')"><label for="<%=inputName%>.true">true</label><br>
										<input type="radio" name="<%=inputName%>" id="<%=inputName%>.false" value="false" 
											onclick="setCurrentValue('false')"><label for="<%=inputName%>.false">false</label>
										<%
									}
									else if (pType instanceof FileParameterType)
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<table border="0" cellspacing="0" cellpadding="0">
										<tr>
										<td><input <%=pType.getNotNull() ? requiredClazz : clazz%> type="text" 
											name="<%=inputName%>" value=""
											size="50"
											onblur="valueOnBlur(this.value)">&nbsp;</td>
										<td><base:button 
												title="Browse&hellip;"
												onclick="<%="browseOnClick('"+inputName+"')"%>"
												/>
										</td>
										</tr>
										</table>
										<%
										if (recentFiles != null && recentFiles.size() > 0)
										{
											%>
											<b>Recently used</b><br>
											<select name="recent.<%=inputName%>" onchange="recentOnChange('<%=inputName%>')">
											<option value="">
											<%
											for (File recent : recentFiles)
											{
												%>
												<option value="<%=recent.getId()%>"><%=HTML.encodeTags(recent.getPath().toString())%>
												<%
											}
											%>
											</select>
											<%
										}
									}
									else if (pType instanceof ItemParameterType)
									{
										Item parameterItemType = Item.fromClass(pType.getParameterClass());
										BasicItem item = (BasicItem)pcRequest.getCurrentParameterValue(param.getName());
										if (item == null)
										{
											ItemContext cc = sc.getCurrentContext(parameterItemType, parameterItemType == itemType ? subContext : "");
											if (cc.getId() != 0)
											{
												try
												{
													item = parameterItemType.getById(dc, cc.getId());
												}
												catch (Throwable t)
												{}
											}
										}
										if (item != null)
										{
											String display = "";
											if (item instanceof Nameable)
											{
												Nameable nameable = (Nameable)item;
												display = nameable.getName();
											}
											else 
											{
												display = item.toString();
											}
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b><br>
											<table border="0" cellspacing="2" cellpadding="0">
											<tr>
											<td><input class="text disabled" size="50" 
												name="<%=inputName%>" type="text" disabled
												value="<%=HTML.encodeTags(display)%>"></td>
											<td><base:button title="Select&hellip;"
													onclick="<%="selectItemOnClick('"+inputName+"', '" + parameterItemType.name() + "')"%>"
													visible="false" /></td>
											<td><base:button title="Clear"
													onclick="<%="clearItemOnClick('"+inputName+"', '" + parameterItemType.name() + "')"%>"
													visible="false" /></td>
											</tr>
											</table>
											<%
										}
									}
									else if (pType instanceof PathParameterType)
									{
										PathParameterType ppType = (PathParameterType)pType;
										String browse = "";
										if (ppType.getPathType() == Path.Type.FILE)
										{
											browse = "saveAsOnClick('" + inputName + "')";
										}
										else
										{
											browse = "selectDirectoryOnClick('" + inputName + "')";
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<table border="0" cellspacing="0" cellpadding="0">
										<tr>
										<td>
											<input type="text" class="text" name="<%=inputName%>" size="40" value=""
												onblur="valueOnBlur(this.value)">&nbsp;</td>
										<td><base:button 
												title="Browse&hellip;"
												onclick="<%=browse%>"
												/>
										</td>
										</tr>
										</table>
										<%
									}
									else
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<%
									}
									%>
									<br>
									<div class="parameterhelp">
									<%=HTML.niceFormat(param.getDescription())%>
									</div>
									</div>
									<%
								}
								else
								{
									%>
									<div id="<%=inputName%>_div" style="display: none;" class="parameterhelp">
									<%=HTML.niceFormat(param.getDescription())%>
									</div>
									<%
								}
							}
						}
					}
					%>
				</td>
			</tr>
			</table>
			</div>
		</form>
		<div align="center">
		<base:buttongroup>
			<base:button onclick="testWithFile()" title="Test with file&hellip;" image="file.gif"
				tooltip="Use an uploaded file to create the regular expressions and column mappings"
				visible="<%=configureByExample%>" />
			<base:button onclick="saveSettings()" title="Next" />
			<base:button onclick="doCancel()" title="Cancel" />
		</base:buttongroup>
		</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
