<%-- $Id: download_file.jsp 5630 2011-05-13 12:54:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"

%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.FILE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath() + "/";
final DbControl dc = sc.newDbControl();
try
{

	File file = File.getById(dc, itemId);
	String path = file.getPath().toString();
	String title = "Download " + path;
	
	if (!file.getLocation().isDownloadable())
	{
		throw new WebException("popup", "File is not online", "The file {1} " +
			"is not online and can't be downloaded", path);
	}
	
	String downloadUrl = root + "filemanager/files/download/-"+ID+"-"+HTML.urlEncode(path);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head>
	<script language="JavaScript">
	function downloadFile()
	{
		location.href = '<%=downloadUrl%>';
	}
	</script>
	</base:head>
	<base:body onload="downloadFile()">

		<h3 class="docked"><%=title%></h3>
		<div class="boxedbottom">
		
			<div class="error">
			If download doesn't start, click on the filename below.
			</div>
		
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">File</td>
				<td><a href="<%=downloadUrl%>"><%=HTML.encodeTags(path)%></a></td>
			</tr>
			<tr>
				<td class="prompt">Content type</td>
				<td>
				<%=HTML.encodeTags(file.getMimeType())%><%
				if (file.getCharacterSet() != null)
				{
					%>; charset=<%=file.getCharacterSet()%>
					<%
				}
				%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Size</td>
				<td><%=Values.formatBytes(file.getSize())%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(file.getDescription())%></td>
			</tr>
			</table>
		</div>
		</form>
		

		<table align="center">
		<tr>
			<td><base:button onclick="window.close()" title="Close" /></td>
		</tr>
		</table>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
