/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	JavaScript functions used on exception handler pages.

	@author Nicklas
	@version 2.16
*/
var Exception = new ExceptionClass(); 

function ExceptionClass()
{
	/*
		Fix the error window by hiding some elements that shouldn't be visisible at
		all times, resize the window, re-display the error message, etc...
	
		@param resizeIfPopup If set, and the window is a popup window, it is resized to
			at least 800x600
	*/
	ExceptionClass.prototype.fixWindow = function(resizeIfPopup)
	{
		var topWindow = window.top;
		var isPopup = topWindow.opener != null;
		
		if (history.length <= 1) // >
		{
			Main.hide('goback');
		}
		if (isPopup)
		{
			// popup window --> Hide menubar
			Main.hide('menubar');
			if (resizeIfPopup)
			{
				var width = Main.getWindowWidth(topWindow);
				var height = Main.getWindowHeight(topWindow);
				if (height < 600) height = 600;
				if (width < 800) width = 800;
				topWindow.resizeTo(width, height);
			}
		}
		else
		{
			// Hide close button
			Main.hide('close');
			// If inside a second frameset, hide menubar
			if (window.parent != window.top)
			{
				Main.hide('menubar');
			}
		}
		if (topWindow.exceptionHandlerCallback) 
		{
			topWindow.exceptionHandlerCallback(window.name);
		}
	}

}

