<%-- $Id: edit_plate.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Plate plate = null;
	
	boolean readCurrentPlateType = true;
	PlateType currentPlateType = null;

	if (itemId == 0)
	{
		title = "Create plate";
		cc.removeObject("item");
		
		int plateTypeId = Values.getInt(request.getParameter("platetype_id"));
		if (plateTypeId != 0)
		{
			currentPlateType = PlateType.getById(dc, plateTypeId);
		}
		else if (cc.getPropertyFilter("plateType.name") != null)
		{
			currentPlateType = Base.getFirstMatching(dc, PlateType.getQuery(), "name", cc.getPropertyFilter("plateType.name"));
		}
	}
	else
	{
		plate = Plate.getById(dc, itemId);
		cc.setObject("item", plate);
		title = "Edit plate -- " + HTML.encodeTags(plate.getName());
		try
		{
			currentPlateType = plate.getPlateType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPlateType = false;
		}
	}
	if (plate != null && !plate.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), plate);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Plate" tab
		function validatePlate()
		{
			var frm = document.forms['plate'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.platetype_id && frm.platetype_id.length == 0)
			{
				alert("You must select a plate type");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['plate'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=plate == null ? 0 : plate.getId()%>);
					annotationsLoaded = true;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		function getParents()
		{
			return new Array();
		}
		function selectPlateTypeOnClick()
		{
			var frm = document.forms['plate'];
			var url = '../platetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPlateTypeCallback';
			if (frm.platetype_id.length > 0) url += '&item_id='+frm.platetype_id[0].value;
			Main.openPopup(url, 'SelectArrayBatch', 1000, 700);
		}
		function setPlateTypeCallback(plateTypeId, name)
		{
			var frm = document.forms['plate'];
			if (frm.platetype_id.length < 1) // >
			{
				frm.platetype_id[frm.platetype_id.length] = new Option();
			}
			frm.platetype_id[0].value = plateTypeId;
			frm.platetype_id[0].text = name;
			frm.platetype_id.selectedIndex = 0;
		}

		function init()
		{
			var frm = document.forms['plate'];
			<%
			if (plate == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="plate" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=plate != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Plate" validate="validatePlate()" helpid="plate.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(plate == null ? Values.getString(cc.getPropertyValue("name"), "New plate") : plate.getName())%>" 
					size="40" maxlength="<%=Plate.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Barcode</td>
				<td><input <%=clazz%> type="text" name="barcode" 
					value="<%=HTML.encodeTags(plate == null ? Values.getString(cc.getPropertyValue("barcode"), "") : plate.getBarcode())%>" 
					size="40" maxlength="<%=Plate.MAX_BARCODE_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt"><label for="destroyed">Destroyed</label></td>
				<td><input type="checkbox" name="destroyed" id="destroyed" value="1"
					<%=(plate != null && plate.isDestroyed()) || (plate == null && Values.getBoolean(cc.getPropertyValue("destroyed"))) ? "checked" : ""%>>
				</td>
			</tr>
			<tr>
				<td class="prompt">Plate type</td>
				<td>
					<%
					if (plate != null)
					{
						%>
						<%=Base.getEncodedName(currentPlateType, !readCurrentPlateType)%>
						<%
					}
					else
					{
						%>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr>
						<td>
							<select name="platetype_id" size="1" 
								<%=!readCurrentPlateType ? "disabled readonly class=\"disabled\"" : "class=\"required\""%>
								style="width: 20em;">
							<%
							if (!readCurrentPlateType)
							{
								%>
								<option value="-1">- denied -
								<%
							}
							else
							{
								if (currentPlateType != null)
								{
									%>
									<option value="<%=currentPlateType.getId()%>" selected><%=HTML.encodeTags(currentPlateType.getName())%>
									<%
								}
							}
							%>
							</select>
							&nbsp;
						</td>
						<td><base:button onclick="selectPlateTypeOnClick()" title="Select&hellip;" /></td>
						</tr>
						</table>
						<%
					}
					%>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(plate == null ? cc.getPropertyValue("description") : plate.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'plate', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
